(** Generated by coq-of-ocaml *)
Require Import CoqOfOCaml.CoqOfOCaml.
Require Import CoqOfOCaml.Settings.

Require Import TezosOfOCaml.Proto_demo.Environment.
Import Environment.Notations.
Require TezosOfOCaml.Proto_demo.Period_repr.

Include Time.

Definition time : Set := t.

(* ❌ Structure item `typext` not handled. *)
(* type_extension *)

(* ❌ Structure item `typext` not handled. *)
(* type_extension *)

(* ❌ Top-level evaluations are ignored *)
(* top_level_evaluation *)

Definition of_seconds_string (s : string) : option t :=
  (* ❌ Try-with are not handled *)
  try (Some (of_seconds (Int64.of_string s))).

Definition to_seconds_string (s : t) : string := Int64.to_string (to_seconds s).

Definition pp : Format.formatter -> t -> unit := pp_hum.

Definition op_plusquestion (x : t) (y : Period_repr.period)
  : Error_monad.tzresult t :=
  (* ❌ Try-with are not handled *)
  try (Error_monad.ok (add x (Period_repr.to_seconds y))).

Definition op_minusquestion (x : t) (y : t)
  : Error_monad.tzresult Period_repr.period :=
  Error_monad.record_trace extensible_type_value
    (Period_repr.of_seconds (diff x y)).
